package org.objectweb.petals.engine.sampleclient;

import java.net.URL;
import java.util.logging.LogManager;

/**
 * 
 * @author ofabre
 * TODO remove this class
 */
public class JBIComponentLogger {
    protected static java.util.logging.Logger jbiComponentLogger;
    
    static
    {
        try 
        {
            URL url = JBIComponentLogger.class.getResource("/logging.properties");
            
            LogManager.getLogManager().readConfiguration(url.openStream());

            jbiComponentLogger = java.util.logging.Logger.getLogger("org.objectweb.petals");
        } 
        catch (Exception e) 
        {
        	// get default logger
            e.printStackTrace();
            jbiComponentLogger = LogManager.getLogManager().getLogger("");
        }
    }
    
    public static void logFinest(String method)
    {
    	jbiComponentLogger.log(java.util.logging.Level.FINEST,method);
    }
    
    public static void logFine(String method)
    {
    	jbiComponentLogger.log(java.util.logging.Level.FINE,method);
    }
    
    public static void logSevere(String msg, Throwable t)
    {
    	jbiComponentLogger.log(java.util.logging.Level.SEVERE,msg,t);
    }
    
    public static void logInfo(String msg)
    {
    	jbiComponentLogger.log(java.util.logging.Level.INFO,msg);
    }
    
    public static void logWarning(String msg)
    {
    	jbiComponentLogger.log(java.util.logging.Level.WARNING,msg);
    }
    
    public static void logWarning(String msg, Throwable t)
    {
    	jbiComponentLogger.log(java.util.logging.Level.WARNING,msg,t);
    }
    
    
    
    public static void logFinest(Object o ,String method)
    {
    	jbiComponentLogger.logp(java.util.logging.Level.FINEST,clazz(o),method,method);
    }
    
    public static void logFine(Object o ,String method)
    {
    	jbiComponentLogger.logp(java.util.logging.Level.FINE,clazz(o),method,method);
    }
    
    public static void logSevere(Object o ,String method, Throwable t)
    {
    	jbiComponentLogger.logp(java.util.logging.Level.SEVERE,clazz(o),method,method,t);
    }
    
    public static void logInfo(Object o ,String method)
    {
    	jbiComponentLogger.logp(java.util.logging.Level.INFO,clazz(o),method,method);
    }
    
    public static void logWarning(Object o ,String method)
    {
    	jbiComponentLogger.logp(java.util.logging.Level.WARNING,clazz(o),method,method);
    }
    
    public static void logWarning(Object o ,String msg, Throwable t)
    {
    	jbiComponentLogger.log(java.util.logging.Level.WARNING,classAndMethod(o,msg),t);
    }
    
    protected static String classAndMethod(Object o, String method)
    {
        return o.getClass().getName()+" "+method;
    }
    protected static String clazz(Object o)
    {
        return o.getClass().getName();
    }
}
