package org.objectweb.petals.classloader;


import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;

import junit.framework.TestCase;

import org.objectweb.petals.PetalsException;

/**
 * @author Rafael Marins
 * @version $Rev: 98 $ $Date: 2006-02-24 17:18:48 +0100 (ven., 24 févr. 2006) $
 */
public class PetalsClassLoaderTest extends TestCase {

//	private static final String RESOURCE_NAME = "ResourceToLoad";

//	private static final String RESOURCE_CONTENTS = "Tue Nov 29, 10:57 AM";

	public void testNothing() {
		
	}

//	public void testLoadResourceFromDirectory() {
//
//		String testdir = getTestingDataDirectory();
//
//		ClassPath cp = new ClassPath();
//		cp.addPathElement(testdir);
//
//		// Try loading resource at first
//		ClassLoader cl = new PetalsClassLoader(cp);
//
//		InputStream in = cl.getResourceAsStream(RESOURCE_NAME);
//		assertNotNull(in);
//
//		// Check if its contents is correct
//		InputStreamReader reader = new InputStreamReader(in);
//		BufferedReader br = new BufferedReader(reader);
//
//		String resourceContent = null;
//		try {
//			resourceContent = br.readLine();
//		} catch (IOException e) {
//			e.printStackTrace();
//		}
//
//		assertEquals(RESOURCE_CONTENTS, resourceContent);
//
//	}

//	public void testLoadResourceFullySpecified() {
//
//		String testdir = getTestingDataDirectory();
//
//		ClassPath cp = new ClassPath();
//		cp.addPathElement(testdir + RESOURCE_NAME);
//
//		// Try loading resource at first
//		ClassLoader cl = new PetalsClassLoader(cp);
//
//		InputStream in = cl.getResourceAsStream(RESOURCE_NAME);
//		assertNotNull(in);
//
//		// Check if its contents is correct
//		InputStreamReader reader = new InputStreamReader(in);
//		BufferedReader br = new BufferedReader(reader);
//
//		String resourceContent = null;
//		try {
//			resourceContent = br.readLine();
//		} catch (IOException e) {
//			e.printStackTrace();
//		}
//
//		assertEquals(RESOURCE_CONTENTS, resourceContent);
//
//	}

//	private String getTestingDataDirectory() {
//		ClassLoader cl = PetalsClassLoaderTest.class.getClassLoader();
//
//		String classFile = PetalsClassLoaderTest.class.getName()
//				.replace('.',File.separatorChar) + ".class";
//
//		String currentPath = cl.getResource(classFile).toString();
//
//		String basePath = currentPath.substring(0,
//				currentPath.length() - classFile.length());
//
//		String testingDataDir = null;
//		try {
//			URL location = new URL(basePath);
//			testingDataDir = location.getPath();
//		} catch (MalformedURLException e) {
//			e.printStackTrace();
//		}
//
//		return testingDataDir;
//	}
	
	public void testLoadClass() {
		LoaderManagerImpl lm = new LoaderManagerImpl();
		URL[] baseUrls = new URL[2];
		try {
			baseUrls[0] = new URL("file:C:/Dev/Workspaces/workspace_test/TestProject/jar/");
			baseUrls[1] = new URL("file:C:/Dev/Workspaces/workspace_test/TestProject/jar2/");
		} catch (MalformedURLException e) {
			e.printStackTrace();
		}
		List<String> classpathLocations = new ArrayList<String>();
		classpathLocations.add("test.jar");
		classpathLocations.add("test2.jar");
		
		PetalsClassLoader pcl = null;
		try {
			pcl =  (PetalsClassLoader) lm.createClassLoader("MonClassLoader", baseUrls, classpathLocations, true);
		} catch (PetalsException e) {
			e.printStackTrace();
		}
		
		Class clazz = null;
		try {
			clazz = pcl.loadClass("org.oli.test.MonTest");

		} catch (ClassNotFoundException e) {
			System.out.println("Error loading class with petals class loarder");
			e.printStackTrace();
		}
		
		Class mainArg[] = {(new String[0]).getClass()};
		
		try {
			Method main = clazz.getMethod("main", mainArg);
			main.invoke(null, new Object[1]);
		} catch (SecurityException e) {
			e.printStackTrace();
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			e.printStackTrace();
		}		
	}

}
