package org.objectweb.petals.engine.sampleclient;

import javax.jbi.JBIException;
import javax.jbi.component.Bootstrap;
import javax.jbi.component.InstallationContext;
import javax.management.ObjectName;

/**
 * 
 * @author ofabre
 *
 */
public class SampleClientBootstrapImpl implements Bootstrap {

	public void cleanUp() throws JBIException {
		System.out.println("Bootstrap called to clean up allocated ressources.");

	}

	public ObjectName getExtensionMBeanName() {
		System.out.println("Bootstrap called to get ExtensionMBeanName.");
		return null;
	}

	public void init(InstallationContext installContext) throws JBIException {
		System.out.println("Bootstrap instance initiated.");

	}

	public void onInstall() throws JBIException {
		System.out.println("Bootstrap instance installed.");

	}

	public void onUninstall() throws JBIException {
		System.out.println("Bootstrap instance uninstalled.");

	}

}
